#!groovy
pipeline {

  agent any

  tools {
      maven 'Maven'
  }

  stages {
    stage('Build') {
      steps {
        echo "Executando build do projeto"
        sh 'mvn clean install'
      }
    }

    stage('Deploy to dev') {
      when {
        branch 'develop'
      }
      steps {
        echo '#########################'
        echo '## Preparing workspace ##'
        echo '#########################'
        sh """
          rm -rf ../spring-docker-example-dev
          mkdir ../spring-docker-example-dev
          mkdir ../spring-docker-example-dev/target
          cp -r Dockerfile ../spring-docker-example-dev/Dockerfile
          cp -r target/*.jar ../spring-docker-example-dev/target/
          cp -r .elasticbeanstalk ../spring-docker-example-dev/.elasticbeanstalk
        """
        echo '##################################'
        echo '## Deploying to dev environment ##'
        echo '##################################'
        withAWS(credentials:'AWS Credencial') {
          sh """
            cd ../spring-docker-example-dev
            eb deploy spring-docker-example-dev
          """
        }
      }
    }

    stage('Deploy to hom') {
      when {
        branch 'release'
      }
      steps {
        echo '#########################'
        echo '## Preparing workspace ##'
        echo '#########################'
        sh """
          rm -rf ../spring-docker-example-hom
          mkdir ../spring-docker-example-hom
          mkdir ../spring-docker-example-hom/target
          cp -r Dockerfile ../spring-docker-example-hom/Dockerfile
          cp -r target/*.jar ../spring-docker-example-hom/target/
          cp -r .elasticbeanstalk ../spring-docker-example-hom/.elasticbeanstalk
        """
        echo '##################################'
        echo '## Deploying to hom environment ##'
        echo '##################################'
        withAWS(credentials:'AWS Credencial') {
          sh """
            cd ../spring-docker-example-hom
            eb deploy spring-docker-example-hom
          """
        }
      }
    }

    stage('Deploy to prd') {
      when {
        branch 'master'
      }
      steps {
        echo '#########################'
        echo '## Preparing workspace ##'
        echo '#########################'
        sh """
          rm -rf ../spring-docker-example-prd
          mkdir ../spring-docker-example-prd
          mkdir ../spring-docker-example-prd/target
          cp -r Dockerfile ../spring-docker-example-prd/Dockerfile
          cp -r target/*.jar ../spring-docker-example-prd/target/
          cp -r .elasticbeanstalk ../spring-docker-example-prd/.elasticbeanstalk
        """
        echo '##################################'
        echo '## Deploying to prd environment ##'
        echo '##################################'
        withAWS(credentials:'AWS Credencial') {
          sh """
            cd ../spring-docker-example-prd
            eb deploy spring-docker-example-prd
          """
        }
      }
    }

  }
}
